//
//  WQWifiMainVC.m
//  JMWireless
//
//  Created by admin on 16/12/7.
//  Copyright © 2016年 unknown. All rights reserved.
//

#import "WQQuickSearchFileManager.h"
#import "SVProgressHUD.h"
#import "WQWifiMainVC.h"
#import "WQConstant.h"
#import "JMWifi.h"

@interface WQWifiMainVC ()
<
    JMWirelessDelegate,
    WQQuickSearchFileManagerDelegate
>
/** 非防丢单发送数据包序号 */
@property (nonatomic, assign) int index;
/** 循环查状态次数 */
@property (nonatomic, assign) int times;
@property (nonatomic, copy) NSData *data;
@property (nonatomic, assign) JMSendType sendType;
@property (nonatomic, strong) WQQuickSearchFileManager *manager;
@property (nonatomic, copy) NSString *imgPath;
@end

@implementation WQWifiMainVC
- (void)viewDidLoad {
    [super viewDidLoad];
    [SVProgressHUD setFadeOutAnimationDuration:0.3];
    [SVProgressHUD setFadeInAnimationDuration:0.3];
    [SVProgressHUD setDefaultStyle:SVProgressHUDStyleCustom];
    [SVProgressHUD setBackgroundColor:[UIColor whiteColor]];
    [SVProgressHUD setDefaultAnimationType:SVProgressHUDAnimationTypeFlat];
    [SVProgressHUD setDefaultMaskType:SVProgressHUDMaskTypeGradient];
    SINGLETONWIFI.delegate  = self;
    self.times = kTIMES;
}

- (IBAction)prnClick:(UIButton *)sender {
    NSLog(@" ");
    WQLog(@"* * *********************** 打 印 图 形 数 据 *********************** * *");
    self.sendType = JMData;
    NSString *path = [[NSBundle mainBundle] pathForResource:kPRNNAME
                                                     ofType:@"prn"];
    self.data = [[NSData alloc] initWithContentsOfFile:path];
    JMContinueTask task = SINGLETONWIFI.isFormRecovery == YES ? JMNoneContinue : JMDisDefendLose;
    [self connect:task];
}

- (IBAction)imgClick:(UIButton *)sender {
    NSLog(@" ");
    WQLog(@"* * *********************** 打 印 图 片 数 据 *********************** * *");
    NSString *path = [[NSBundle mainBundle] pathForResource:kIMGNAME
                                                     ofType:@"png"];
    [self imagePrintWithPath:path];
}

- (IBAction)feedClick:(UIButton *)sender {
    NSLog(@" ");
    WQLog(@"* * *********************** 打 印 进 纸 指 令 *********************** * *");
    self.sendType = JMData;
    
    // 进纸指令
    Byte feedByte[] = {27,74,255};
    self.data = [NSData dataWithBytes:feedByte
                               length:sizeof(feedByte)];
    JMContinueTask task = SINGLETONWIFI.isFormRecovery == YES ? JMNoneContinue : JMDisDefendLose;
    [self connect:task];
}

- (IBAction)backClick:(UIButton *)sender {
    NSLog(@" ");
    WQLog(@"* * *********************** 打 印 退 纸 指 令 *********************** * *");
    self.sendType = JMData;
    
    // 退纸指令
    Byte backByte[] = {27,106,255};
    self.data = [NSData dataWithBytes:backByte
                               length:sizeof(backByte)];
    JMContinueTask task = SINGLETONWIFI.isFormRecovery == YES ? JMNoneContinue : JMDisDefendLose;
    [self connect:task];
}

- (IBAction)txtClick:(UIButton *)sender {
    NSLog(@" ");
    WQLog(@"* * *********************** 打 印 文 本 数 据 *********************** * *");
    NSString *path = [[NSBundle mainBundle] pathForResource:kTEXTNAME
                                                     ofType:@"txt"];
    [self filePrintWithPath:path];
}

- (IBAction)stringClick:(UIButton *)sender {
    NSLog(@" ");
    WQLog(@"* * *********************** 打 印 字 符 数 据 *********************** * *");
    NSString *str = @"\t静夜诗\n\
    床前明月光，\n\
    疑似地上霜。\n\
    举头望明月，\n\
    低头思故乡。\n\
    \r\n";
    self.sendType = JMData;
    self.data = [str dataUsingEncoding:
                 CFStringConvertEncodingToNSStringEncoding(kCFStringEncodingGB_18030_2000)];
    JMContinueTask task = SINGLETONWIFI.isFormRecovery == YES ? JMNoneContinue : JMDisDefendLose;
    [self connect:task];
}

- (IBAction)htmlClick:(UIButton *)sender {
    NSLog(@" ");
    WQLog(@"* * *********************** 打 印 网 页 数 据 *********************** * *");
    NSString *path = [[NSBundle mainBundle] pathForResource:kHTMNAME
                                                     ofType:@"html"];
    [self htmlPrintWithPath:path];
}

- (IBAction)jsonClick:(UIButton *)sender {
    NSLog(@" ");
    WQLog(@"* * *********************** 打 印 JSON 数 据 *********************** * *");
    NSString *path = [[NSBundle mainBundle] pathForResource:kJSONNAME
                                                     ofType:@"json"];
    [self jsonPrintWithPath:path];
}

- (IBAction)fileClick:(UIBarButtonItem *)sender {
    NSLog(@" ");
    WQLog(@"* * *********************** 打 印 文 件 数 据 *********************** * *");
    self.manager = [[WQQuickSearchFileManager alloc] init];
    self.manager.delegate = self;
    NSString *rootPath = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,
                                                             NSUserDomainMask,
                                                             YES)[0];
    [self.manager showRootDirectory:rootPath];
}

- (void)imagePrintWithPath:(NSString *)path {
    self.imgPath = path;
    self.sendType = JMImg;
    JMContinueTask task = SINGLETONWIFI.isFormRecovery == YES ? JMNoneContinue : JMDisDefendLose;
    [self connect:task];
}

- (void)filePrintWithPath:(NSString *)path {
    self.sendType = JMData;
    self.data = [[NSData alloc] initWithContentsOfFile:path];
    JMContinueTask task = SINGLETONWIFI.isFormRecovery == YES ? JMNoneContinue : JMDisDefendLose;
    [self connect:task];
}

- (void)htmlPrintWithPath:(NSString *)path {
    NSData *html = [NSData dataWithContentsOfFile:path];
    [SVProgressHUD showWithStatus:JMLocalized(@"HTML transform")];
    [SINGLETONWIFI transformHtmlToData:html
                                  type:JMThermal
                             completed:^(NSError * _Nullable error,
                                         NSData  * _Nullable data) {
                                 if (error) {
                                     [SVProgressHUD showErrorWithStatus:[NSString stringWithFormat:@"%@\n %@",
                                                                         JMLocalized(@"HTML transform exception"),error.localizedDescription]];
                                     WQLogError(@"HTML 数据转换错误: %@",error);
                                     return ;
                                 }
                                 self.data = data;
                                 JMContinueTask task = SINGLETONWIFI.isFormRecovery == YES ? JMNoneContinue : JMDisDefendLose;
                                 [self connect:task];
                             }];
}

- (void)jsonPrintWithPath:(NSString *)path {
    NSData *json = [NSData dataWithContentsOfFile:path];
    [SVProgressHUD showWithStatus:JMLocalized(@"JSON tranform")];
    [SINGLETONWIFI transformJsonToData:json
                                  type:JMThermal
                             completed:^(NSError * _Nullable error,
                                         NSData  * _Nullable data) {
                                 if (error) {
                                     [SVProgressHUD showErrorWithStatus:[NSString stringWithFormat:@"%@\n %@",
                                                                         JMLocalized(@"JSON transform exception"),error.localizedDescription]];
                                     WQLogError(@"JSON 数据转换错误: %@",error);
                                     return ;
                                 }
                                 self.data = data;
                                 JMContinueTask task = SINGLETONWIFI.isFormRecovery == YES ? JMNoneContinue : JMDisDefendLose;
                                 [self connect:task];
                             }];
}



#pragma mark -- WQQuickSearchFileManagerDelegate
- (void)selectedFilePath:(NSString *)path {
    NSString *last = [path lastPathComponent];
    NSString *extension = [[last pathExtension] lowercaseString];
    if ([extension isEqualToString:@"png"]
        || [extension isEqualToString:@"jpg"]
        || [extension isEqualToString:@"jpeg"]
        || [extension isEqualToString:@"gif"]) {
        // 图片打印
        [self imagePrintWithPath:path];
    }else if ([extension isEqualToString:@"json"]) {
        // JSON 打印
        [self jsonPrintWithPath:path];
    }else if ([extension isEqualToString:@"html"]) {
        // HTML 打印
        [self htmlPrintWithPath:path];
    }else {
        // 文件打印
        [self filePrintWithPath:path];
    }
}



#pragma mark -- 连 接
- (void)connect:(JMContinueTask)task {
    if (SINGLETONWIFI.ip == nil) {
        [SVProgressHUD setMinimumDismissTimeInterval:2.f];
        [SVProgressHUD showErrorWithStatus:JMLocalized(@"IP is empty")];
        return;
    }
    [SVProgressHUD showWithStatus:JMLocalized(@"Connecting printer...")];
    [SINGLETONWIFI connectWithHost:SINGLETONWIFI.ip
                              port:SINGLETONWIFI.port
                      formRecovery:SINGLETONWIFI.isFormRecovery
                          complete:^(NSError *error) {
                              if (error) {
                                  WQLogError(@"error: %@ -- isConnect: %d",
                                             error,SINGLETONWIFI.isConnected);
                                  [SVProgressHUD setMinimumDismissTimeInterval:2.f];
                                  [SVProgressHUD showErrorWithStatus:[NSString stringWithFormat:@"%@: %@",
                                                                      JMLocalized(@"Connection task error"),error.localizedDescription]];
                                  [SINGLETONWIFI disconnect];
                                  return ;
                              }
                              WQLogMsg(@"连接成功 -- 类型: %d -- isConnect: %d",
                                       SINGLETONWIFI.printerType,SINGLETONWIFI.isConnected);
                              switch (task) {
                                  case JMDisDefendLose:{
                                      // 非防丢单打印
                                      [SVProgressHUD showWithStatus:JMLocalized(@"Send Task")];
                                      [self sendData];
                                      break;
                                  }
                                  case JMNoneContinue:{
                                      // 无续发
                                      [self statusTask1];
                                      break;
                                  }
#warning 断点续发规则: \
1、数据发送中途出错，且没有调用 -disconnect 函数时可以实现断点续发 \
2、续发时，函数回调的 block 可以为 nil，block 为 nil 时调用发送时的 block
                                  case JMStartContinue:{
                                      // 重发开始
                                      [SVProgressHUD showWithStatus:JMLocalized(@"Start task")];
                                      [SINGLETONWIFI startTask:nil];
                                      break;
                                  }
                                  case JMsendContinue:{
                                      // 重发数据
                                      [SVProgressHUD showWithStatus:JMLocalized(@"Send Task")];
                                      [SINGLETONWIFI sendTask:nil
                                                    completed:nil];
                                      break;
                                  }
                                  case JMFinishContinue:{
                                      // 重发结束
                                      [SVProgressHUD showWithStatus:JMLocalized(@"Finish task")];
                                      [SINGLETONWIFI finishTask:nil];
                                      break;
                                  }
                                  case JMStatusContinue:{
                                      // 重发查状态
                                      [SVProgressHUD showWithStatus:JMLocalized(@"Check the state task")];
                                      [SINGLETONWIFI statusTask:nil];
                                      break;
                                  }
                              }
                          }];
}


#pragma mark -- 非 防 丢 单 打 印
#warning 非防丢单打印规则: \
1、连接打印机 \
2、发送打印数据 \
3、断开连接

#pragma mark ---- JMWirelessDelegate
- (void)wifiDidconnected:(NSError *)error {
    if (error) {
        WQLogError(@"断开连接: %@ -- isConnect: %d",
                   error,SINGLETONWIFI.isConnected);
    } else {
        WQLogMsg(@"断开连接 -- isConnected: %d"
                 ,SINGLETONWIFI.isConnected);
    }
}

/**
 *  非防丢单打印数据发送完成回调
 *
 *  @param error 发送错误
 */
- (void)wirelessSendOver:(NSError *)error {
    if (error) {
        WQLogError(@"发送出错: %@ -- isConnected: %d",
                   error,SINGLETONWIFI.isConnected);
        [SINGLETONWIFI disconnect];
        self.index = 0;
        [SVProgressHUD setMinimumDismissTimeInterval:2.f];
        [SVProgressHUD showErrorWithStatus:[NSString stringWithFormat:@"%@: %@",
                                            JMLocalized(@"Send error"),error.localizedDescription]];
        return;
    }
    self.index ++;
    [self sendData];
}

- (void)sendData {
    NSData *data;
    NSMutableArray *dataArr = [[NSMutableArray alloc] init];
    switch (self.sendType) {
        case JMImg:{
            UIImage *img = [UIImage imageWithContentsOfFile:self.imgPath];
            data = [SINGLETONWIFI transformImageToData:img
                                                  type:SINGLETONWIFI.printerType];
            break;
        }
        default:{
            data = self.data;
            break;
        }
    }
    // 每包数据长度为 512
    int len = 512;
    if (SINGLETONWIFI.printerType == JMInkjet) {
        // 喷墨打印机数据长度为 1024*50
        len = 1024*8;
    }
    // 总共分包数
    int packageCount = data.length % len > 0 ? (int)data.length / len + 1 : (int)data.length / len;
    for (int index = 0; index < packageCount; index ++) {
        int subLocation = index * len;
        int subLen = subLocation + len > data.length ? ((int)data.length - subLocation) : len;
        NSData *subData = [data subdataWithRange:NSMakeRange(subLocation, subLen)];
        
        // 保存数据包
        [dataArr addObject:subData];
    }
    if (self.index >= packageCount) {
        WQLogMsg(@"打印完成");
        self.index = 0;
        self.sendType = JMData;
        [SINGLETONWIFI disconnect];
        [SVProgressHUD setMinimumDismissTimeInterval:2.f];
        [SVProgressHUD showSuccessWithStatus:JMLocalized(@"Print complete")];
        return;
    }
    WQLogMsg(@"总包: %d -- 发送: %d",packageCount,self.index);
    [SINGLETONWIFI sendTask:dataArr[self.index]
                  completed:nil];
}


#pragma mark -- 防 丢 单 打 印
#warning 防丢单打印规则: \
1、连接打印机 \
2、查打印机状态 \
3、发送开始打印任务 \
4、发送打印数据 \
5、发送结束任务 \
6、循环查状态直到打印结束 \
7、断开连接
- (void)statusTask1 {
    [SVProgressHUD showWithStatus:JMLocalized(@"Check the state task")];
    [SINGLETONWIFI statusTask:^(NSError * _Nullable error,
                                NSData  * _Nullable status) {
        if (error) {
            WQLogError(@"查状态出错: %@ -- isConnected: %d",
                       error,SINGLETONWIFI.isConnected);
            [SVProgressHUD dismiss];
            UIAlertController *alert = [self showAlert:JMLocalized(@"Check the state error")
                                              subTitle:error.localizedDescription
                                                  sure:^(UIAlertAction *action) {
                                                      // 重试查询
                                                      [self connect:JMStatusContinue];
                                                  }
                                                cancel:^(UIAlertAction *action) {
                                                    // 断开连接
                                                    [SINGLETONWIFI disconnect];
                                                }];
            [self.navigationController presentViewController:alert
                                                    animated:YES
                                                  completion:nil];
            return ;
        }
        if (status) {
            // 有状态
            WQLogInfo(@"当前状态: %@",status);
            Byte *b = (Byte *)status.bytes;
            if (b[0] & 128) {
                // 打印机正在打印
                [SVProgressHUD dismiss];
                UIAlertController *alert = [self showAlert:JMLocalized(@"The printer is printing")
                                                  subTitle:JMLocalized(@"Forced to print the ticket?")
                                                      sure:^(UIAlertAction *action) {
                                                          if (SINGLETONWIFI.isConnected) {
                                                              [self startTask];
                                                          }else {
                                                              // 重试查询
                                                              [self connect:JMStatusContinue];
                                                          }
                                                      }
                                                    cancel:^(UIAlertAction *action) {
                                                        [SINGLETONWIFI disconnect];
                                                    }];
                [self.navigationController presentViewController:alert
                                                        animated:YES
                                                      completion:nil];
                return;
            }
            [self startTask];
        }else {
            // 无状态
            [SINGLETONWIFI disconnect];
            [SVProgressHUD setMinimumDismissTimeInterval:2.f];
            [SVProgressHUD showErrorWithStatus:@"The printer state is empty"];
        }
    }];
}

- (void)startTask {
    [SVProgressHUD showWithStatus:JMLocalized(@"Start task")];
    [SINGLETONWIFI startTask:^(NSError * _Nullable error) {
        if (error) {
            WQLogError(@"开始任务出错: %@ -- isConnect: %d",
                       error,SINGLETONWIFI.isConnected);
            [SVProgressHUD dismiss];
            UIAlertController *alert = [self showAlert:JMLocalized(@"Start task error")
                                              subTitle:error.localizedDescription
                                                  sure:^(UIAlertAction *action) {
                                                      // 重试开始
                                                      [self connect:JMStartContinue];
                                                  }
                                                cancel:^(UIAlertAction *action) {
                                                    // 断开连接
                                                    [SINGLETONWIFI disconnect];
                                                }];
            [self.navigationController presentViewController:alert
                                                    animated:YES
                                                  completion:nil];
            return ;
        }
        WQLogMsg(@"开始任务成功");
        [self sendTask];
    }];
}

- (void)sendTask {
    [SVProgressHUD showWithStatus:JMLocalized(@"Send Task")];
    NSData *data;
    switch (self.sendType) {
        case JMImg:{
            UIImage *img = [UIImage imageWithContentsOfFile:self.imgPath];
            data = [SINGLETONWIFI transformImageToData:img
                                                  type:SINGLETONWIFI.printerType];
            break;
        }
        default:{
            data = self.data;
            break;
        }
    }
    [SINGLETONWIFI sendTask:data
                  completed:^(NSError *error) {
                      if (error) {
                          WQLogError(@"发送任务错误: %@ -- isConnect: %d",
                                     error,SINGLETONWIFI.isConnected);
                          [SVProgressHUD dismiss];
                          UIAlertController *alert = [self showAlert:JMLocalized(@"Send task error")
                                                            subTitle:error.localizedDescription
                                                                sure:^(UIAlertAction *action) {
                                                                    // 重试开始
                                                                    [self connect:JMsendContinue];
                                                                }
                                                              cancel:^(UIAlertAction *action) {
                                                                  // 断开连接
                                                                  [SINGLETONWIFI disconnect];
                                                              }];
                          [self.navigationController presentViewController:alert
                                                                  animated:YES
                                                                completion:nil];
                          return ;
                      }
                      WQLogMsg(@"发送完成");
                      [self finishTask];
                  }];
}

- (void)finishTask {
    [SVProgressHUD showWithStatus:JMLocalized(@"Finish task")];
    [SINGLETONWIFI finishTask:^(NSError * _Nullable error) {
        if (error) {
            WQLogError(@"结束任务出错: %@ -- isConnect: %d",
                       error,SINGLETONWIFI.isConnected);
            [SVProgressHUD dismiss];
            UIAlertController *alert = [self showAlert:JMLocalized(@"Finish task error")
                                              subTitle:error.localizedDescription
                                                  sure:^(UIAlertAction *action) {
                                                      // 重试开始
                                                      [self connect:JMFinishContinue];
                                                  }
                                                cancel:^(UIAlertAction *action) {
                                                    // 断开连接
                                                    [SINGLETONWIFI disconnect];
                                                }];
            [self.navigationController presentViewController:alert
                                                    animated:YES
                                                  completion:nil];
            return ;
        }
        WQLogMsg(@"结束任务成功");
        [self statusTask2];
    }];
}

- (void)statusTask2 {
    [SVProgressHUD showWithStatus:JMLocalized(@"Check the state task")];
    [SINGLETONWIFI statusTask:^(NSError * _Nullable error,
                                NSData  * _Nullable status) {
        if (error) {
            WQLogError(@"查状态出错: %@ -- isConnected: %d",
                       error,SINGLETONWIFI.isConnected);
            [SVProgressHUD dismiss];
            self.times = kTIMES;
            UIAlertController *alert = [self showAlert:JMLocalized(@"Check the state error")
                                              subTitle:error.localizedDescription
                                                  sure:^(UIAlertAction *action) {
                                                      // 重试开始
                                                      [self connect:JMStatusContinue];
                                                  }
                                                cancel:^(UIAlertAction *action) {
                                                    // 断开连接
                                                    [SINGLETONWIFI disconnect];
                                                }];
            [self.navigationController presentViewController:alert
                                                    animated:YES
                                                  completion:nil];
            return ;
        }
        if (status) {
            WQLogInfo(@"当前状态: %@",status);
            self.times --;
            Byte *b = (Byte *)status.bytes;
            if (b[0] & 64) {
                // 打印中途出错
                self.times = kTIMES;
                [SVProgressHUD dismiss];
                [SINGLETONWIFI disconnect];
                UIAlertController *alert = [self showAlert:JMLocalized(@"Instrument is not complete")
                                                  subTitle:JMLocalized(@"Print error")
                                                      sure:^(UIAlertAction *action) {
                                                          // 重打
                                                          JMContinueTask task = SINGLETONWIFI.isFormRecovery == YES ? JMNoneContinue : JMDisDefendLose;
                                                          [self connect:task];
                                                      }
                                                    cancel:^(UIAlertAction *action) {
                                                        // 断开连接
                                                        self.sendType = JMData;
                                                        [SINGLETONWIFI disconnect];
                                                    }];
                [self.navigationController presentViewController:alert
                                                        animated:YES
                                                      completion:nil];
            }else if (b[0] & 32) {
                // 打印结束
                self.data = nil;
                self.times = kTIMES;
                [SINGLETONWIFI disconnect];
                self.sendType = JMData;
                [SVProgressHUD setMinimumDismissTimeInterval:2.f];
                [SVProgressHUD showSuccessWithStatus:JMLocalized(@"Print complete")];
            }else {
                if (self.times < 0) {
                    // 查询次数超限
                    self.times = kTIMES;
                    [SVProgressHUD dismiss];
                    UIAlertController *alert = [self showAlert:JMLocalized(@"The printer is printing")
                                                      subTitle:JMLocalized(@"Whether or not to continue to track the status of the printer?")
                                                          sure:^(UIAlertAction *action) {
                                                              // 断续查询状态
                                                              [SVProgressHUD showWithStatus:JMLocalized(@"Check the state task")];
                                                              [SINGLETONWIFI statusTask:nil];
                                                          }
                                                        cancel:^(UIAlertAction *action) {
                                                            // 断开连接
                                                            self.sendType = JMData;
                                                            [SINGLETONWIFI disconnect];
                                                        }];
                    [self.navigationController presentViewController:alert
                                                            animated:YES
                                                          completion:nil];
                    return;
                }
                // 还在打印中，1s 后再查状态
                [NSThread sleepForTimeInterval:1.f];
                [SINGLETONWIFI statusTask:nil];
            }
        }else {
            self.data = nil;
            self.times = kTIMES;
            [SINGLETONWIFI disconnect];
            self.sendType = JMData;
            [SVProgressHUD setMinimumDismissTimeInterval:2.f];
            [SVProgressHUD showErrorWithStatus:JMLocalized(@"The printer state is empty")];
        }
    }];
}

- (UIAlertController *)showAlert:(NSString *)title
                        subTitle:(NSString *)subTitle
                            sure:(void (^ __nullable)(UIAlertAction *action))sHandler
                          cancel:(void (^ __nullable)(UIAlertAction *action))cHandler {
    UIAlertController *alert = [UIAlertController alertControllerWithTitle:title
                                                                   message:subTitle
                                                            preferredStyle:UIAlertControllerStyleAlert];
    // 确定
    UIAlertAction *sure = [UIAlertAction actionWithTitle:JMLocalized(@"Retry")
                                                   style:UIAlertActionStyleDefault
                                                 handler:sHandler];
    // 取消
    UIAlertAction *cancel = [UIAlertAction actionWithTitle:JMLocalized(@"Cancel")
                                                     style:UIAlertActionStyleDestructive
                                                   handler:cHandler];
    [alert addAction:sure];
    [alert addAction:cancel];
    return alert;
}
@end







